<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="generator" content="https://txt2tags.org">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans&display=swap">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Oswald:400,700">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Montserrat">
<link rel="stylesheet" href="https://www.dicas-l.com.br/css/responsee.css">
<link rel="stylesheet" href="../style/extra.css">
<style>
blockquote{margin: 1em 2em; border-left: 2px solid #999;
  font-style: oblique; padding-left: 1em;}
blockquote:first-letter{margin: .2em .1em .1em 0; font-size: 160%; font-weight: bold;}
blockquote:first-line{font-weight: bold;}
body{font-family: sans-serif;}
hr{background-color:#000;border:0;color:#000;}
hr.heavy{height:2px;}
hr.light{height:1px;}
img{border:0;display:block;}
img.right{margin:0 0 0 auto;}
img.center{border:0;margin:0 auto;}
table{border-collapse: collapse;}
table th,table td{padding: 3px 7px 2px 7px;}
table th{background-color: lightgrey;}
table.center{margin-left:auto; margin-right:auto;}
.center{text-align:center;}
.right{text-align:right;}
.left{text-align:left;}
.tableborder,.tableborder td,.tableborder th{border:1px solid #000;}
.underline{text-decoration:underline;}
</style>
</head>
<body>
<header>
<hgroup>
</hgroup>
</header>


<div class="body">

<section>
<h1>Peneirando arquivos armazenados num tar.gz</h1>

<p>
Essa dica nasceu de uma troca de ideias no grupo privado de Telegram do curso <em><a href="https://www.dicas-l.com.br/educacao/index/programacao-shell-linux">Programação Shell Linux</a></em> ministrado por nosso estimado professor <a href="http://linkedin.com/in/juliocezarneves">Julio</a> <em><a href="http://linkedin.com/in/juliocezarneves">Papai do Shell</a></em> <a href="http://linkedin.com/in/juliocezarneves">Neves</a> e administrado por <a href="http://linkedin.com/in/rubens-queiroz-8a21a2">Rubens Queiroz</a>, o grande responsável pela <a href="https://www.dicas-l.com.br">Dicas-L</a> que há décadas nos brinda com gotas de conhecimento.
</p>
<p>
O colega <a href="http://linkedin.com/in/cesarlinux">Cesar Rizzo</a>, aluno de uma das primeiras turmas do curso, propôs o desafio de inspecionar via <code>grep</code> o conteúdo de arquivos <code>tar.gz</code> indicando, na saída, as linhas casadas em associação aos arquivos que as contenham.
</p>

</section>
<section>
<h1>TL;DR</h1>

<p>
Como o artigo acabou bem mais longo que o esperado, em consideração aos apressadinhos vou apresentar a dica logo duma vez.
</p>

<pre class="comandos">
$ export TAR_OPTIONS=--ignore-command-error
$ ls *.tar* | xargs -I+ tar xf + --to-command='grep --label=$TAR_ARCHIVE:$TAR_FILENAME -H w.rd'
<span class="saida">t1.tar.bz2:f2.txt:linha 2, word 2</span>
<span class="saida">t1.tar.gz:f2.txt:linha 2, word 2</span>
<span class="saida">t1.tar.gz:f3.txt:linha 3, w0rd 3</span>
<span class="saida">t2.tar:f3.txt:linha 3, w0rd 3</span>
<span class="saida">t2.tar:f5.txt:linha 2, w.rd 2</span>
<span class="saida">t2.tar:f5.txt:linha 3, w0rd 3</span>
<span class="saida">t2.tar.gz:f3.txt:linha 3, w0rd 3</span>
<span class="saida">t2.tar.gz:f5.txt:linha 2, w.rd 2</span>
<span class="saida">t2.tar.gz:f5.txt:linha 3, w0rd 3</span>
<span class="saida">t2.tar.xz:f3.txt:linha 3, w0rd 3</span>
<span class="saida">t2.tar.xz:f5.txt:linha 2, w.rd 2</span>
<span class="saida">t2.tar.xz:f5.txt:linha 3, w0rd 3</span>
</pre>

<p>
Quem quiser ou precisar um detalhamento adequado encontrará abaixo as informações necessárias.
</p>

<hr class="light">

<p>
Já são razoavelmente conhecidos os comandos <code>zgrep</code> e <code>zipgrep</code>. Eles permitem pesquisar por ocorrências de expressões regulares dentro de arquivos compactados nos formatos <strong><a href="http://wikipedia.org/wiki/LZ77">LZ77</a></strong> do <code>gzip</code> e <strong><a href="http://wikipedia.org/wiki/ZIP_%28file_format%29">ZIP</a></strong> do <code>zip</code>, respectivamente.
</p>
<p>
Exemplo:
</p>

<pre class="comandos">
$ grep . f?.txt
<span class="saida">f1.txt:linha 1, palavra 1</span>
<span class="saida">f1.txt:linha 2, palavra 2</span>
<span class="saida">f1.txt:linha 3, palavra 3</span>

<span class="saida">f2.txt:linha 1, palavra 1</span>
<span class="saida">f2.txt:linha 2, word 2</span>
<span class="saida">f2.txt:linha 3, palavra 3</span>

<span class="saida">f3.txt:linha 1, palavra 1</span>
<span class="saida">f3.txt:linha 2, palavra 2</span>
<span class="saida">f3.txt:linha 3, w0rd 3</span>

<span class="saida">f4.txt:linha 1, palavra - 1</span>
<span class="saida">f4.txt:linha 2, palavra - 2</span>
<span class="saida">f4.txt:linha 3, palavra - 3</span>

<span class="saida">f5.txt:linha 1, palavra 1</span>
<span class="saida">f5.txt:linha 2, w.rd 2</span>
<span class="saida">f5.txt:linha 3, w0rd 3</span>

$ ls -1 f?.txt.gz
<span class="saida">f1.txt.gz</span>
<span class="saida">f2.txt.gz</span>
<span class="saida">f3.txt.gz</span>
<span class="saida">f4.txt.gz</span>

$ unzip -l f.zip
<span class="saida">Archive:  f.zip</span>
<span class="saida">  Length      Date    Time    Name</span>
<span class="saida">---------  ---------- -----   ----</span>
<span class="saida">       57  2023-06-12 23:27   f1.txt</span>
<span class="saida">       54  2023-06-12 23:27   f2.txt</span>
<span class="saida">       54  2023-06-12 23:28   f3.txt</span>
<span class="saida">       63  2023-06-12 23:28   f4.txt</span>
<span class="saida">       51  2023-06-15 06:21   f5.txt</span>
<span class="saida">---------                     -------</span>
<span class="saida">      279                     5 files</span>

$ zgrep w.rd f?.txt.gz
<span class="saida">f2.txt.gz:linha 2, word 2</span>
<span class="saida">f3.txt.gz:linha 3, w0rd 3</span>
<span class="saida">f5.txt.gz:linha 2, w.rd 2</span>
<span class="saida">f5.txt.gz:linha 3, w0rd 3</span>

$ zipgrep w.rd f.zip
<span class="saida">f2.txt:linha 2, word 2</span>
<span class="saida">f3.txt:linha 3, w0rd 3</span>
<span class="saida">f5.txt:linha 2, w.rd 2</span>
<span class="saida">f5.txt:linha 3, w0rd 3</span>
</pre>

<p>
A diferença entre um e outro está relacionada com o modo como cada formato armazena o arquivo: o formato <strong>LZ77</strong> armazena/compacta apenas um arquivo por <em>archive</em>, enquanto o formato <strong>ZIP</strong> armazena vários. Isso nos deixa num beco sem saída quando temos vários arquivos armazenados em um <em>archive</em> <strong>tar.gz</strong>:
</p>

<pre class="comandos">
$ ls -1 *.tar.gz
<span class="saida">t1.tar.gz</span>
<span class="saida">t2.tar.gz</span>
<span class="saida">t3.tar.gz</span>

$ zgrep w.rd t1.tar.gz
<span class="saida">grep: t1.tar.gz: arquivo binário coincide com o padrão</span>
</pre>

<p>
Para compactar vários arquivos com o <code>gzip</code>, mas em um único <em>archive</em>, primeiro encapsulamos todos em um arquivo <strong>tar</strong> (<em>tape archive</em>) e depois compactamos esse arquivo com o <code>gzip</code>.
</p>
<p>
Mas como pesquisar o conteúdo dos arquivos nesse caso, sem ter que explicitamente descompactá-lo, mantendo um comportamento equivalente ao <code>zgrep</code> e ao <code>zipgrep</code>?
</p>

<hr class="light">

<p>
O comando <code>tar</code> tem um parâmetro pouco conhecido mas que lhe adiciona um poder significativo: <code>--to-command</code>.
</p>
<p>
Com ele podemos indicar uma linha de comando que processará a saída do <code>tar</code> modificando o resultado bruto original. No caso, o que queremos é que os arquivos compactados sejam analisados pelo <code>grep</code> à procura de linhas que casem com uma expressão regular e, se encontradas ocorrências, que sejam mostrados o nome do arquivo e o conteúdo dessa linha.
</p>
<p>
O comando <code>grep</code>, por sua vez, tem o parâmetro <code>-H</code> (<code>--with-filename</code>) que prefixa com o nome do arquivo cada linha que casar com a expressão de pesquisa e que vai ao encontro de uma das nossas especificações.
</p>
<p>
Mas como os dados que serão processados pelo <code>grep</code> são passado do <code>tar</code> para ele pela entrada padrão e não por um arquivo propriamente dito, para relacionar as linhas casadas ao arquivo que está em análise utilizaremos o parâmetro <code>--label</code> do <code>grep</code>. Esse parâmetro prefixa cada linha casada pelo <code>grep</code> com um rótulo fornecido como valor. A esperteza consiste em alimentar o <code>--label</code> com o nome do arquivo que está chegando pela entrada padrão. Isso fará a associação &lt;nome do arquivo&gt;—&lt;conteúdo da linha&gt;.
</p>
<p>
Vamos exemplificar o comportamento geral desses dois parâmetros do <code>grep</code>:
</p>

<pre class="comandos">
$ grep w.rd f2.txt
<span class="saida">linha 2, word 2</span>

$ grep -H w.rd f2.txt
<span class="saida">f2.txt:linha 2, word 2</span>

$ grep w.rd &lt; f2.txt
<span class="saida">linha 2, word 2</span>

$ grep -H w.rd &lt; f2.txt
<span class="saida">(entrada padrão):linha 2, word 2</span>

$ grep --label="um label qualquer" -H w.rd &lt; f2.txt
<span class="saida">um label qualquer:linha 2, word 2</span>

$ grep --label=f2.txt -H w.rd &lt; f2.txt
<span class="saida">f2.txt:linha 2, word 2</span>
</pre>

<p>
O parâmetro <code>--to-command</code> fornece um conjunto muito útil de variáveis internas que disponibilizam diversas informações sobre os arquivos armazenados e o <em>archive</em> que os contém. Elas podem ser usadas com o comando desejado para modificar o resultado do que seria a extração do conteúdo do <strong>tar.gz</strong> processado por esse comando. A variável <code>$TAR_FILENAME</code>, por exemplo, supre o nome do arquivo em processamento pelo <code>tar</code> e pode ser colocada como valor do parâmetro <code>--label</code> para fazer as vezes de “um label qualquer” ao prefixar as linhas casadas pelo <code>grep</code> com seu parâmetro <code>-H</code>.
</p>
<p>
Então, juntando tudo:
</p>

<pre class="comandos">
$ tar ztf t2.tar.gz
<span class="saida">f1.txt</span>
<span class="saida">f3.txt</span>
<span class="saida">f5.txt</span>

$ tar zxf t2.tar.gz \
  --to-command='grep --label=$TAR_FILENAME -H w.rd; true'
<span class="saida">f3.txt:linha 3, w0rd 3</span>
<span class="saida">f5.txt:linha 2, w.rd 2</span>
<span class="saida">f5.txt:linha 3, w0rd 3</span>
</pre>

<p>
O que aconteceu aí?
</p>

<section>
<h2>1º) o shell</h2>

<p>
O <code>tar</code>, ao executar um comando externo via opção <code>--to-command</code>, invoca o <em>shell</em> <code>/bin/sh</code> e executa o comando para cada arquivo do <em>archive</em>. Podemos executar qualquer comando:
</p>

<pre class="comandos">
$ tar zxf t2.tar.gz --to-command='echo $TAR_FILENAME'
<span class="saida">f1.txt</span>
<span class="saida">f3.txt</span>
<span class="saida">f5.txt</span>
</pre>

<p>
<code>/bin/sh</code> não passa de um nome genérico e costuma ser um <em>link</em> simbólico que aponta para algum <em>shell</em> específico, normalmente <code>ash</code>, <code>dash</code> ou <code>bash</code>. Por isso, o comportamento do <em>shell</em> durante a execução do comando seguirá a sintaxe do <em>shell</em> alvo deste <em>link</em>. No Ubuntu, por exemplo, <code>/bin/sh</code> aponta por padrão para o <code>dash</code>. Uma das características do <code>dash</code> é que o comando <code>echo</code> não precisa do parâmetro <code>-e</code> para ecoar uma nova linha (<code>\n</code>), ao contrário do <code>bash</code>:
</p>

<pre class="comandos">
$ dash -c 'echo "a\nb"'
<span class="saida">a</span>
<span class="saida">b</span>

$ dash -c 'echo -e "a\nb"'
<span class="saida">-e a</span>
<span class="saida">b</span>

$ bash -c 'echo "a\nb"'
<span class="saida">a\nb</span>

$ bash -c 'echo -e "a\nb"'
<span class="saida">a</span>
<span class="saida">b</span>
</pre>

<p>
Modificando o alvo do <em>link</em>, obviamente teremos um comportamento coerente com o novo <em>shell</em>:
</p>

<pre class="comandos">
$ ls -l /bin/sh
<span class="saida">lrwxrwxrwx 1 root root 4 jun 13 22:58 /bin/sh -&gt; dash</span>

$ tar xf t2.tar --to-command='echo "a\nb\n"'
<span class="saida">a</span>
<span class="saida">b</span>

<span class="saida">a</span>
<span class="saida">b</span>

$ sudo ln -fs bash /bin/sh
$ ls -l /bin/sh
<span class="saida">lrwxrwxrwx 1 root root 4 jun 13 23:37 /bin/sh -&gt; bash</span>

$ tar xf t2.tar --to-command='echo "a\nb\n"'
<span class="saida">a\nb\n</span>
<span class="saida">a\nb\n</span>

$ tar xf t2.tar --to-command='echo -e "a\nb\n"'
<span class="saida">a</span>
<span class="saida">b</span>

<span class="saida">a</span>
<span class="saida">b</span>

$ sudo ln -fs dash /bin/sh
</pre>

<p>
2º) o <code>true</code>
</p>
<p>
A menos que o <code>tar</code> receba a opção <code>--ignore-command-error</code>, o comando da opção <code>--to-command</code> <strong>PRECISA finalizar com <em>status</em> 0</strong>, caso contrário o <code>tar</code> vai “gritar”. Para garantir o status 0, a técnica mais tradicional é finalizar o comando com um <code>true</code>. Como <code>true</code>é um comando “longo” se comparado com seu <em>alias</em> <code>:</code> e como esse <em>alias</em> existe tanto no <code>bash</code> quanto no <code>dash</code>, por uma questão de concisão podemos adotá-lo. Se acontecer de por acaso usarmos algum <em>shell</em> que <strong>não tenha</strong> o comando <code>:</code> ou que ele não seja equivalente ao <code>true</code>, então deverá ser usado especificamente <code>true</code> <strong>OU</strong> qualquer outro comando que <strong>garantidamente</strong> finalize com <em>status</em> 0:
</p>

<pre class="comandos">
$ tar xf t2.tar --to-command='true'

$ tar xf t2.tar --to-command='false'
<span class="saida">tar: 2930675: Child returned status 1</span>
<span class="saida">tar: 2930676: Child returned status 1</span>
<span class="saida">tar: 2930677: Child returned status 1</span>
<span class="saida">tar: Saindo com status de falha em razão de erros anteriores</span>

$ tar xf t2.tar --to-command='false' --ignore-command-error

$ tar xf t2.tar --to-command='false; :'

$ tar xf t2.tar --to-command='grep --label=$TAR_ARCHIVE:$TAR_FILENAME -H w.rd'
<span class="saida">tar: 2930728: Child returned status 1</span>
<span class="saida">t2.tar:f3.txt:linha 3, w0rd 3</span>
<span class="saida">t2.tar:f5.txt:linha 2, w.rd 2</span>
<span class="saida">t2.tar:f5.txt:linha 3, w0rd 3</span>
<span class="saida">tar: Saindo com status de falha em razão de erros anteriores</span>

$ tar xf t2.tar --to-command='grep --label=$TAR_ARCHIVE:$TAR_FILENAME -H w.rd' --ignore-command-error
$ tar xf t2.tar --to-command='grep --label=$TAR_ARCHIVE:$TAR_FILENAME -H w.rd; :'
$ tar xf t2.tar --to-command='grep --label=$TAR_ARCHIVE:$TAR_FILENAME -H w.rd; true'
$ tar xf t2.tar --to-command='grep --label=$TAR_ARCHIVE:$TAR_FILENAME -H w.rd; exit 0'
$ tar xf t2.tar --to-command='grep --label=$TAR_ARCHIVE:$TAR_FILENAME -H w.rd; return 0'
$ tar xf t2.tar --to-command='grep --label=$TAR_ARCHIVE:$TAR_FILENAME -H w.rd; echo -n'
<span class="saida">t2.tar:f3.txt:linha 3, w0rd 3</span>
<span class="saida">t2.tar:f5.txt:linha 2, w.rd 2</span>
<span class="saida">t2.tar:f5.txt:linha 3, w0rd 3</span>

$ tar xf t2.tar --to-command='grep --label=$TAR_ARCHIVE:$TAR_FILENAME -H w.rd; echo FIM'
<span class="saida">FIM</span>
<span class="saida">t2.tar:f3.txt:linha 3, w0rd 3</span>
<span class="saida">FIM</span>
<span class="saida">t2.tar:f5.txt:linha 2, w.rd 2</span>
<span class="saida">t2.tar:f5.txt:linha 3, w0rd 3</span>
<span class="saida">FIM</span>
</pre>

<p>
Vejam que a <em>string</em> <code>FIM</code> foi ecoada 3 vezes no último exemplo porque o comando foi executado para cada um dos 3 arquivos do <em>archive</em>. Em apenas dois deles a expressão regular <code>w.rd</code> casou com alguma linha, mas para todos o <code>echo</code> foi executado.
</p>
<p>
Então, a menos que se tenha uma boa razão para permitir que o <code>tar</code> finalize a execução do comando com um status diferente de 0, mais simples que emendar um <code>true</code> (ou algo que o valha) ao final do comando, é utilizar a opção <code>--ignore-command-error</code>. Para não precisarmos ficar arrastando um parâmetro desse tamanho para cá e para lá, outra medida interessante é utilizar a variável de ambiente <code>TAR_OPTIONS</code> do <code>tar</code>:
</p>

<pre class="comandos">
$ tar xf t2.tar --to-command='grep --label=$TAR_ARCHIVE:$TAR_FILENAME -H w.rd'
<span class="saida">tar: 2931703: Child returned status 1</span>
<span class="saida">t2.tar:f3.txt:linha 3, w0rd 3</span>
<span class="saida">t2.tar:f5.txt:linha 2, w.rd 2</span>
<span class="saida">t2.tar:f5.txt:linha 3, w0rd 3</span>
<span class="saida">tar: Saindo com status de falha em razão de erros anteriores</span>

$ tar xf t2.tar --to-command='grep --label=$TAR_ARCHIVE:$TAR_FILENAME -H w.rd' --ignore-command-error
<span class="saida">t2.tar:f3.txt:linha 3, w0rd 3</span>
<span class="saida">t2.tar:f5.txt:linha 2, w.rd 2</span>
<span class="saida">t2.tar:f5.txt:linha 3, w0rd 3</span>

$ export TAR_OPTIONS=--ignore-command-error
$ tar xf t2.tar --to-command='grep --label=$TAR_ARCHIVE:$TAR_FILENAME -H w.rd'
<span class="saida">t2.tar:f3.txt:linha 3, w0rd 3</span>
<span class="saida">t2.tar:f5.txt:linha 2, w.rd 2</span>
<span class="saida">t2.tar:f5.txt:linha 3, w0rd 3</span>
</pre>

<hr class="light">

<p>
Enfim, isso já parece legal e atinge o objetivo, mas pode ficar melhor.
</p>
<p>
E se tivermos vários <em>archives</em> <strong>tar.gz</strong> e quisermos inspecionar todos, listando o conteúdo casado em associação com o nome do <em>archive</em> que o contém, mas apenas dos que possuírem algum arquivo casando com a expressão; como proceder?
</p>
<p>
Até poderíamos fazer um <em>loop</em> iterando o comando acima entre os <em>archives</em> com o padrão <code>*.tar.gz</code>, claro. Mas o shell é mais sobre os <em>loops</em> implícitos de seus comandos malandros que sobre os <em>loops</em> explícitos característicos das linguagens tradicionais.
</p>
<p>
Nesse espírito, vamos deixar o <code>for</code>, o <code>while</code> e o <code>until</code> de lado e usar o poderoso <code>xargs</code>.
</p>

<pre class="comandos">
$ ls -1 *.tar.gz
<span class="saida">t1.tar.gz</span>
<span class="saida">t2.tar.gz</span>
<span class="saida">t3.tar.gz</span>

$ export TAR_OPTIONS=--ignore-command-error

$ ls *.tar.gz |
  xargs -I+ tar zxf + \
  --to-command='grep --label=$TAR_FILENAME -H w.rd'
<span class="saida">f2.txt:linha 2, word 2</span>
<span class="saida">f3.txt:linha 3, w0rd 3</span>
<span class="saida">f3.txt:linha 3, w0rd 3</span>
<span class="saida">f5.txt:linha 2, w.rd 2</span>
<span class="saida">f5.txt:linha 3, w0rd 3</span>
</pre>

<p>
OK, devolveu 5 ocorrências distribuídas em 3 arquivos de 3 <em>archives</em>. Falta saber que <em>archives</em> possuem os arquivos com ocorrências.
</p>
<p>
Para explicitar isso vamos usar outra variável interna: <code>$TAR_ARCHIVE</code>. Ela armazena o nome do <em>archive</em> de onde estão sendo processados os arquivos (com o <code>grep</code>, no caso). Inclusive, se não adotarmos a opção que caracteriza especificamente o tipo de compactação usada, por default será adotada a opção <code>-a</code> (<code>--auto-compress</code>) do <code>tar</code>, tornando possível inspecionar de uma única vez <em>archives</em> compactados com os vários tipos de compressão suportadas pelo comando.
</p>
<p>
Outra possibilidade interessante é usar as inúmeras opções do <code>grep</code> para modificar o resultado devolvido:
</p>

<pre class="comandos">
$ ls -1 *.tar*
<span class="saida">t1.tar.bz2</span>
<span class="saida">t1.tar.gz</span>
<span class="saida">t2.tar</span>
<span class="saida">t2.tar.gz</span>
<span class="saida">t2.tar.xz</span>
<span class="saida">t3.tar.gz</span>
<span class="saida">t3.tar.Z</span>

$ export TAR_OPTIONS=--ignore-command-error

$ ls *.tar* |
  xargs -I+ tar xf + \
            --to-command='
              grep \
              --color=always \
              --label=$TAR_ARCHIVE:$TAR_FILENAME \
<span class="saida">              -HP "w\K.(?=rd)"</span>
<span class="saida">            '</span>
</pre>

<p>
  <img class="center" src="saida1.png" alt="">Saída 1
</p>
<p>
Se, ao invés de emendarmos <code>$TAR_ARCHIVE</code> e <code>$TAR_FILENAME</code> como label no <code>grep</code>, armazenarmos o resultado correspondido pelo <code>grep</code> para depois utilizá-lo, podemos criar uma saída um pouco mais sofisticada:
</p>

<pre class="comandos">
$ export TAR_OPTIONS=--ignore-command-error tmp=/dev/shm/archive
$ ls *.tar* |
  xargs -I+ tar xf + \
            --to-command='
<span class="saida">              if match=$(</span>
                   grep                  \
                   --color=always        \
                   --label=$TAR_FILENAME \
<span class="saida">                   -HP "w\K.(?=rd)"</span>
<span class="saida">                 )</span>
<span class="saida">              then</span>
<span class="saida">                arc=$TAR_ARCHIVE</span>
<span class="saida">                grep -qx $arc $tmp &amp;amp;&amp;amp;</span>
                lbl= ||
                {
<span class="saida">                  echo $arc &gt; $tmp</span>
<span class="saida">                  lbl="[\e[1;33m$arc\e[0m]\n"</span>
<span class="saida">                }</span>
<span class="saida">                echo "$lbl$match"</span>
<span class="saida">              fi</span>
<span class="saida">            '</span>
</pre>

<p>
  <img class="center" src="saida2.png" alt="">Saída 2
</p>
<p>
O comando externo executado pelo <code>tar</code> começou a ficar meio complexo. Agora, se <code>/bin/sh</code> apontar para o <code>bash</code>, poderemos usufruir de facilidades que simplificarão a composição desse comando. Uma delas é a possibilidade de usar funções previamente definidas e exportadas para o uso no <code>tar</code>. Infelizmente o <code>dash</code> não exporta funções, seria necessário usar um <em>script</em> armazenado em em um arquivo.
</p>

<pre class="comandos">
$ sudo ln -fs bash /bin/sh

$ grepintar()
<span class="saida">  {</span>
<span class="saida">    tmp=/dev/shm/archive</span>
<span class="saida">    if match=$(</span>
         grep           \
         --color=always \
         --label=$$2    \
<span class="saida">         -HP "w\K.(?=rd)"</span>
<span class="saida">       )</span>
<span class="saida">    then</span>
<span class="saida">      if grep -qx $1 $tmp</span>
<span class="saida">      then</span>
<span class="saida">        lbl=</span>
<span class="saida">      else</span>
<span class="saida">        echo $1 &gt; $tmp</span>
<span class="saida">        lbl="[\e[1;33m$1\e[0m]\n"</span>
<span class="saida">      fi</span>
<span class="saida">      echo -e "$lbl$match"</span>
<span class="saida">    fi</span>
<span class="saida">  }</span>

$ export TAR_OPTIONS=--ignore-command-error

$ ls *.tar* | xargs -I+ tar xf + --to-command='grepintar $TAR_ARCHIVE $TAR_FILENAME'
<span class="saida">/bin/sh: linha 1: grepintar: comando não encontrado [18 vezes]</span>

$ export -f grepintar
$ ls *.tar* | xargs -I+ tar xf + --to-command='grepintar $TAR_ARCHIVE $TAR_FILENAME'
<span class="saida">[resultado idêntico à saída 2]</span>
</pre>

<p>
E já que voltamos a falar da troca do <em>shell</em> usado pelo <code>tar</code>, sim, mesmo um <em>shell</em> alienígena como o <a href="http://github.com/PowerShell/PowerShell">PowerShell</a> pode ser usado:
</p>

<pre class="comandos">
$ sudo ln -fs /usr/bin/pwsh /bin/sh
$ ls -l /bin/sh
<span class="saida">lrwxrwxrwx 1 root root 13 jun 14 01:32 /bin/sh -&gt; /usr/bin/pwsh</span>

$ tar xf t2.tar --to-command='sls -noemphasis -path $env:TAR_FILENAME w.rd'

<span class="saida">f3.txt:3:linha 3, w0rd 3</span>

$ tar xf t2.tar --to-command='sls -noemphasis -path $env:TAR_FILENAME w.rd | % { $_.filename+":"+$_.line }'
<span class="saida">f3.txt:linha 3, w0rd 3</span>

$ ls *.tar* | xargs -I@ tar xf @ --to-command='sls -noemphasis -path $env:TAR_FILENAME w.rd | % { $env:TAR_ARCHIVE + ":" + $_.filename + ":" + $_.line }'
<span class="saida">t1.tar.bz2:f2.txt:linha 2, word 2</span>
<span class="saida">t1.tar.gz:f2.txt:linha 2, word 2</span>
<span class="saida">t2.tar:f3.txt:linha 3, w0rd 3</span>
<span class="saida">t2.tar.gz:f3.txt:linha 3, w0rd 3</span>
<span class="saida">t2.tar.xz:f3.txt:linha 3, w0rd 3</span>
</pre>

<p>
Detalhe, nesse último exemplo, para a necessidade de adotar no <code>xargs</code> uma <em>string</em> de substituição que não esteja sendo usada no comando do powershell, como por exemplo <code>@</code>.
</p>

</section>
<section>
<h2>A lista de variáveis</h2>

<p>
A lista de variáveis disponibilizadas pelo parâmetro <code>--to-command</code> do <code>tar</code> é bem completa. Provê informações relacionadas ao comando <code>tar</code> em si, ao <em>archive</em> aberto e ao arquivo armazenado que está sendo processado:
</p>

 <ul>
 <li><code>TAR_VERSION</code> número da versão do GNU <code>tar</code>
 </li>
 <li><code>TAR_ARCHIVE</code> nome do <em>archive</em> <strong>tar</strong> que está sendo processado
 </li>
 <li><code>TAR_FORMAT</code> formato do <em>archive</em> sendo processado
 </li>
 <li><code>TAR_BLOCKING_FACTOR</code> número de blocos de 512 bytes em um registro
 </li>
 <li><code>TAR_VOLUME</code> número ordinal do volume que o <code>tar</code> está processando se estiver lendo um <em>archive</em> de vários volumes
 </li>
 <li><code>TAR_SUBCOMMAND</code> opção curta precedida por um traço descrevendo a operação que o <code>tar</code> está executando
 </li>
 <li><code>TAR_FILENAME</code> nome do arquivo
 </li>
 <li><code>TAR_REALNAME</code> nome do arquivo conforme armazenado no <em>archive</em>
 </li>
 <li><code>TAR_FILETYPE</code> uma única letra significando o tipo do arquivo
 </li>
 <li><code>TAR_MODE</code> modo de arquivo em octal
 </li>
 <li><code>TAR_SIZE</code> tamanho do arquivo
 </li>
 <li><code>TAR_ATIME</code> hora do último acesso, número decimal representando a quantidade de segundos do <em>Unix Timestamp</em>
 </li>
 <li><code>TAR_MTIME</code> hora da última modificação
 </li>
 <li><code>TAR_CTIME</code> hora da última mudança de status
 </li>
 <li><code>TAR_UNAME</code> nome do dono do arquivo
 </li>
 <li><code>TAR_GNAME</code> nome do grupo de proprietários do arquivo
 </li>
 <li><code>TAR_UID</code> UID do proprietário do arquivo
 </li>
 <li><code>TAR_GID</code> GID do proprietário do arquivo
 <p></p>
O comando fornecido ao parâmetro <code>--to-command</code> será executado para cada arquivo armazenado no <em>archive</em>. O <code>grep</code> é apenas a aplicação mais óbvia, talvez. Poderíamos dar um <code>cat</code>:
 <p></p>

<pre class="comandos">
$ tar xf t2.tar --to-command='echo Conteúdo de $TAR_FILENAME:; cat; echo'
<span class="saida">Conteúdo de f1.txt:</span>
<span class="saida">linha 1, palavra 1</span>
<span class="saida">linha 2, palavra 2</span>
<span class="saida">linha 3, palavra 3</span>

<span class="saida">Conteúdo de f3.txt:</span>
<span class="saida">linha 1, palavra 1</span>
<span class="saida">linha 2, palavra 2</span>
<span class="saida">linha 3, w0rd 3</span>
</pre>

 <p></p>
Portanto, uma forma de inspecionar o valor de alguma(s) das variáveis internas do <code>tar</code> (<code>TAR_...</code>) é simplesmente dar um <code>echo</code> nela(s):
 <p></p>

<pre class="comandos">
$ tar xf t2.tar --to-command='echo "$TAR_VERSION\n$TAR_FILENAME\n$TAR_SIZE"; echo'
<span class="saida">1.34</span>
<span class="saida">f1.txt</span>
<span class="saida">57</span>

<span class="saida">1.34</span>
<span class="saida">f3.txt</span>
<span class="saida">54</span>
</pre>

 <p></p>
Para inspecionar TODAS as variáveis, podemos fazer algo mais simples:
 <p></p>

<pre class="comandos">
$ tar xf t2.tar --to-command='set | grep ^TAR_; echo'
<span class="saida">TAR_ARCHIVE='t2.tar'</span>
<span class="saida">TAR_ATIME='1686706888.594238697'</span>
<span class="saida">TAR_BLOCKING_FACTOR='20'</span>
<span class="saida">TAR_CTIME='1686706888.594238697'</span>
<span class="saida">TAR_FILENAME='f1.txt'</span>
<span class="saida">TAR_FILETYPE='f'</span>
<span class="saida">TAR_FORMAT='gnu'</span>
<span class="saida">TAR_GID='10101'</span>
<span class="saida">TAR_GNAME='arkanon'</span>
<span class="saida">TAR_MODE='0664'</span>
<span class="saida">TAR_MTIME='1686623249'</span>
<span class="saida">TAR_REALNAME='f1.txt'</span>
<span class="saida">TAR_SIZE='57'</span>
<span class="saida">TAR_UID='10101'</span>
<span class="saida">TAR_UNAME='arkanon'</span>
<span class="saida">TAR_VERSION='1.34'</span>
<span class="saida">TAR_VOLUME='1'</span>

<span class="saida">TAR_ARCHIVE='t2.tar'</span>
<span class="saida">TAR_ATIME='1686706888.594238697'</span>
<span class="saida">TAR_BLOCKING_FACTOR='20'</span>
<span class="saida">TAR_CTIME='1686706888.594238697'</span>
<span class="saida">TAR_FILENAME='f3.txt'</span>
<span class="saida">TAR_FILETYPE='f'</span>
<span class="saida">TAR_FORMAT='gnu'</span>
<span class="saida">TAR_GID='10101'</span>
<span class="saida">TAR_GNAME='arkanon'</span>
<span class="saida">TAR_MODE='0664'</span>
<span class="saida">TAR_MTIME='1686623307'</span>
<span class="saida">TAR_REALNAME='f3.txt'</span>
<span class="saida">TAR_SIZE='54'</span>
<span class="saida">TAR_UID='10101'</span>
<span class="saida">TAR_UNAME='arkanon'</span>
<span class="saida">TAR_VERSION='1.34'</span>
<span class="saida">TAR_VOLUME='1'</span>
</pre>

 </li>
 </ul>

</section>
</section>
<section>
<h1>Comandos usados nesse artigo:</h1>

 <ul>
 <li><a href="http://learn.microsoft.com/powershell/module/microsoft.powershell.core/foreach-object">%</a> (<code>pwsh</code>: <em>alias</em> do comando <code>foreach-object</code>)
 </li>
 <li><a href="http://gnu.org/software/bash/manual/bash.html#index-_003a">:</a> (<code>bash</code>: <em>alias</em> do comando <code>true</code>)
 </li>
 <li><a href="http://man.page/ash">ash</a>
 </li>
 <li><a href="http://man.page/bash">bash</a>
 </li>
 <li><a href="http://man.page/cat">cat</a>
 </li>
 <li><a href="http://man7.org/linux/man-pages/man1/dash.1.html">dash</a>
 </li>
 <li><a href="http://gnu.org/software/bash/manual/bash.html#index-echo">echo</a> (<code>bash</code>)
 </li>
 <li><a href="http://gnu.org/software/bash/manual/bash.html#index-export">export</a> (<code>bash</code>)
 </li>
 <li><a href="http://gnu.org/software/bash/manual/bash.html#index-exit">exit</a> (<code>bash</code>)
 </li>
 <li><a href="http://ss64.com/bash/false.html">false</a> (<code>bash</code>)
 </li>
 <li><a href="http://man.page/grep">grep</a>
 </li>
 <li><a href="http://gnu.org/software/bash/manual/bash.html#index-if">if</a> (<code>bash</code>)
 </li>
 <li><a href="http://man.page/ln">ln</a>
 </li>
 <li><a href="http://man.page/ls">ls</a>
 </li>
 <li><a href="http://learn.microsoft.com/powershell/scripting/learn/ps101/01-getting-started">pwsh</a>
 </li>
 <li><a href="http://gnu.org/software/bash/manual/bash.html#index-return">return</a> (<code>bash</code>)
 </li>
 <li><a href="http://gnu.org/software/bash/manual/bash.html#index-set">set</a> (<code>bash</code>)
 </li>
 <li><a href="http://learn.microsoft.com/powershell/module/microsoft.powershell.utility/select-string">sls</a> (<code>pwsh</code>: <em>alias</em> do comando <code>select-string</code>)
 </li>
 <li><a href="http://man.page/sudo">sudo</a>
 </li>
 <li><a href="http://man.page/tar">tar</a>
 </li>
 <li><a href="http://ss64.com/bash/true.html">true</a> (<code>bash</code>)
 </li>
 <li><a href="http://man.page/xargs">xargs</a>
 </li>
 <li><a href="http://man.page/zgrep">zgrep</a>
 </li>
 <li><a href="http://man.page/zipgrep">zipgrep</a>
 </li>
 </ul>

</section>
<section>
<h1>TODO</h1>

 <ul>
 <li>apresentar um exemplo usando powershell
 </li>
 <li>exemplificar como inspecionar variáveis internas do <code>tar</code>
 </li>
 <li>explicar o motivo do <code>echo</code> ecoar <code>\n</code> sem o parâmetro <code>-e</code>
 </li>
 <li>explicar porque <code>--to-command</code> termina com <code>:</code>
 </li>
 <li>linkar a lista de comandos aos seus man’s
 </li>
 <li>listar outras variáveis internas
 </li>
 <li>mencionar que funciona também com outras compactações do <code>tar</code>
 </li>
 <li>mencionar que outros parâmetros do <code>grep</code>podem ser usados, em especial o <code>-E</code>, <code>-P</code>, <code>-i</code>, <code>-v</code> e <code>--color=always</code>
 <p></p>
☐
 </li>
 </ul>

</section>
</div>
</body></html>
